## deal.ii 8.1.0

=== CMakeLists.txt ===
## ---------------------------------------------------------------------
## $Id: CMakeLists.txt 31861 2013-12-03 17:45:43Z maier $
##
## Copyright (C) 2012 - 2013 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE at
## the top level of the deal.II distribution.
##
## ---------------------------------------------------------------------


##                                                                    ##
#            The cmake build system for the deal.II project            #
#                                                                      #
#    See doc/readme.html and doc/development/cmake.html for further    #
#    details on how to use the cmake build system of deal.II.          #
##                                                                    ##

########################################################################
#                                                                      #
#                            Configuration:                            #
#                                                                      #
########################################################################

#
# General configuration for cmake:
#
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.8)
MESSAGE(STATUS "This is CMake ${CMAKE_VERSION}")

LIST(APPEND CMAKE_MODULE_PATH
  ${CMAKE_SOURCE_DIR}/cmake/
  ${CMAKE_SOURCE_DIR}/cmake/modules/
  )

#
# Load all macros:
#
INCLUDE(setup_external_macros)
FILE(GLOB _macro_files "cmake/macros/*.cmake")
FOREACH(_file ${_macro_files})
  INCLUDE(${_file})
ENDFOREACH()

#
# Check for the existence of various optional folders:
#
IF(EXISTS ${CMAKE_SOURCE_DIR}/bundled/CMakeLists.txt)
  SET(DEAL_II_HAVE_BUNDLED_DIRECTORY TRUE)
ENDIF()

IF(EXISTS ${CMAKE_SOURCE_DIR}/doc/CMakeLists.txt)
  SET(DEAL_II_HAVE_DOC_DIRECTORY TRUE)
ENDIF()

IF(NOT DEFINED TEST_DIR)
  GET_FILENAME_COMPONENT(TEST_DIR "${CMAKE_SOURCE_DIR}" PATH)
  SET(TEST_DIR "${TEST_DIR}/tests")
ENDIF()
IF(EXISTS ${TEST_DIR}/CMakeLists.txt)
  SET(DEAL_II_HAVE_TESTS_DIRECTORY TRUE)
ENDIF()

#
# We have to initialize some cached variables before PROJECT is called, so
# do it at this point:
#
INCLUDE(setup_cached_variables)

#
# Now, set the project and set up the rest:
#
PROJECT(deal.II CXX)
ENABLE_LANGUAGE_OPTIONAL(C)
ENABLE_LANGUAGE_OPTIONAL(Fortran)

INCLUDE(setup_deal_ii)

INCLUDE(setup_compiler_flags)

#
# Include information about bundled libraries:
#
IF(DEAL_II_HAVE_BUNDLED_DIRECTORY)
  FILE(GLOB _check_files "bundled/*.cmake")
  LIST(SORT _check_files)
  FOREACH(_file ${_check_files})
    MESSAGE(STATUS "")
    MESSAGE(STATUS "Include ${_file}")
    INCLUDE(${_file})
  ENDFOREACH()
ENDIF()

#
# Run all system checks:
#
FILE(GLOB _check_files "cmake/checks/*.cmake")
LIST(SORT _check_files)
FOREACH(_file ${_check_files})
  MESSAGE(STATUS "")
  MESSAGE(STATUS "Include ${_file}")
  INCLUDE(${_file})
ENDFOREACH()

#
# Feature configuration:
#
FILE(GLOB _configure_files "cmake/configure/configure_*.cmake")
LIST(SORT _configure_files) # make sure to include in alphabetical order
FOREACH(_file ${_configure_files})
  MESSAGE(STATUS "")
  MESSAGE(STATUS "Include ${_file}")
  INCLUDE(${_file})
ENDFOREACH()

#
# Finalize the configuration:
#
INCLUDE(setup_custom_targets)
INCLUDE(setup_finalize)


########################################################################
#                                                                      #
#                     Compilation and installation:                    #
#                                                                      #
########################################################################

MESSAGE(STATUS "")
MESSAGE(STATUS "Configuring done. Proceed to target definitions now.")

ADD_SUBDIRECTORY(cmake/scripts)
ADD_SUBDIRECTORY(include)

IF(DEAL_II_HAVE_DOC_DIRECTORY)
  ADD_SUBDIRECTORY(doc) # has to be included after include
ENDIF()

IF(DEAL_II_HAVE_BUNDLED_DIRECTORY)
  ADD_SUBDIRECTORY(bundled)
ENDIF()
ADD_SUBDIRECTORY(source) # has to be included after bundled

ADD_SUBDIRECTORY(cmake/config) # has to be included after source
ADD_SUBDIRECTORY(contrib) # has to be included after source
ADD_SUBDIRECTORY(examples)

INCLUDE(setup_testsuite)

#
# And finally, print the configuration:
#
FILE(READ ${CMAKE_BINARY_DIR}/summary.log DEAL_II_LOG_SUMMARY)
MESSAGE("${DEAL_II_LOG_SUMMARY}")

=== contrib/CMakeLists.txt ===
## ---------------------------------------------------------------------
## $Id: CMakeLists.txt 31861 2013-12-03 17:45:43Z maier $
##
## Copyright (C) 2012 - 2013 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE at
## the top level of the deal.II distribution.
##
## ---------------------------------------------------------------------

IF(DEAL_II_COMPONENT_MESH_CONVERTER)
  MESSAGE(STATUS "Setup mesh_converter")
  ADD_SUBDIRECTORY(mesh_conversion)
  MESSAGE(STATUS "Setup mesh_converter - Done")
ENDIF()

IF(DEAL_II_COMPONENT_PARAMETER_GUI)
  MESSAGE(STATUS "Setup parameter_gui")
  ADD_SUBDIRECTORY(parameter_gui)
  MESSAGE(STATUS "Setup parameter_gui - Done")
ENDIF()

=== doc/CMakeLists.txt ===
## ---------------------------------------------------------------------
## $Id: CMakeLists.txt 31903 2013-12-06 01:13:08Z maier $
##
## Copyright (C) 2012 - 2013 by the deal.II Authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE at
## the top level of the deal.II distribution.
##
## ---------------------------------------------------------------------

#
# Set up all necessary bits for the documentation
#
IF(DEAL_II_COMPONENT_DOCUMENTATION)

  MESSAGE(STATUS "Setup documentation")

  ADD_SUBDIRECTORY(doxygen)

  #
  # Install the static elements of the html documentation:
  #
  INSTALL(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/
    DESTINATION ${DEAL_II_DOCHTML_RELDIR}
    COMPONENT documentation
    PATTERN "CMakeLists.txt" EXCLUDE
    PATTERN "doxygen" EXCLUDE
    PATTERN "*.in" EXCLUDE
    )

  CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/title.html.in
    ${CMAKE_CURRENT_BINARY_DIR}/title.html
    )
  INSTALL(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/title.html
    DESTINATION ${DEAL_II_DOCHTML_RELDIR}
    COMPONENT documentation
    )

  MESSAGE(STATUS "Setup documentation - Done")

ENDIF(DEAL_II_COMPONENT_DOCUMENTATION)

#
# Always install a minimalistic README and LICENSE file:
#

# Bloody hack to get an empty relative path:
IF(NOT "${DEAL_II_DOCREADME_RELDIR}" STREQUAL "")
  SET(_foo ${DEAL_II_DOCREADME_RELDIR})
ELSE()
  SET(_foo \${__empty})
ENDIF()

SET(_destination)
INSTALL(FILES
  ${CMAKE_SOURCE_DIR}/README
  ${CMAKE_SOURCE_DIR}/LICENSE
  DESTINATION ${_foo}
  COMPONENT library
  )

=== examples/CMakeLists.txt ===
## ---------------------------------------------------------------------
## $Id: CMakeLists.txt 31861 2013-12-03 17:45:43Z maier $
##
## Copyright (C) 2012 - 2013 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE at
## the top level of the deal.II distribution.
##
## ---------------------------------------------------------------------

IF(DEAL_II_COMPONENT_EXAMPLES)
  MESSAGE(STATUS "Setup examples")

  INSTALL(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/
    DESTINATION ${DEAL_II_EXAMPLES_RELDIR}
    COMPONENT examples
    FILES_MATCHING
    #
    # Exclude folder structures: doc, doxygen, CMakeFiles,...
    #
    PATTERN "CMakeFiles*" EXCLUDE
    PATTERN "doc*" EXCLUDE
    PATTERN "doxygen*" EXCLUDE
    PATTERN ".svn*" EXCLUDE
    #
    # Glob Includes:
    #
    PATTERN "*.cc"
    PATTERN "*.prm"
    PATTERN "*.inp"
    PATTERN "step*/CMakeLists.txt"
    #
    # Special files:
    #
    PATTERN "output.reference.dat" # step-39
    PATTERN "postprocess.pl"       # step-39
    PATTERN "obstacle_file.pbm"    # step-42
    PATTERN "untitled.geo"         # step-49
    PATTERN "untitled.msh"         # step-49
    )

  MESSAGE(STATUS "Setup examples - Done")
ENDIF()

=== include/CMakeLists.txt ===
## ---------------------------------------------------------------------
## $Id: CMakeLists.txt 31527 2013-11-03 09:58:45Z maier $
##
## Copyright (C) 2012 - 2013 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE at
## the top level of the deal.II distribution.
##
## ---------------------------------------------------------------------

#
# Configure config.h
#
CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/deal.II/base/config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/deal.II/base/config.h
  )

#
# Add a rule for how to install the header files:
#
INSTALL(DIRECTORY deal.II
  DESTINATION ${DEAL_II_INCLUDE_RELDIR}
  COMPONENT library
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE
  )

#
# and don't forget to install all generated header files, too:
#
INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/deal.II
  DESTINATION ${DEAL_II_INCLUDE_RELDIR}
  COMPONENT library
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE
  )

=== source/CMakeLists.txt ===
## ---------------------------------------------------------------------
## $Id: CMakeLists.txt 31861 2013-12-03 17:45:43Z maier $
##
## Copyright (C) 2012 - 2013 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE at
## the top level of the deal.II distribution.
##
## ---------------------------------------------------------------------

MESSAGE(STATUS "Setup library")

#
# Compile the deal.II library
#

INCLUDE_DIRECTORIES(
  BEFORE # Ensure deal.II include directories come first
  #
  # Reverse order due to BEFORE:
  #
  ${CMAKE_SOURCE_DIR}/include/
  ${CMAKE_BINARY_DIR}/include/
  )

#
# List the directories where we have source files. the ones with the longest
# compile jobs come first so that 'make -j N' saturates many processors also
# towards the end of compiling rather than having to wait for one long
# compilation that, because it has been listed last, is started towards the
# end of everything (e.g. numerics/vectors.cc takes several minutes to
# compile...)
#
ADD_SUBDIRECTORY(numerics)
ADD_SUBDIRECTORY(fe)
ADD_SUBDIRECTORY(dofs)
ADD_SUBDIRECTORY(lac)
ADD_SUBDIRECTORY(base)
ADD_SUBDIRECTORY(grid)
ADD_SUBDIRECTORY(hp)
ADD_SUBDIRECTORY(multigrid)
ADD_SUBDIRECTORY(distributed)
ADD_SUBDIRECTORY(algorithms)
ADD_SUBDIRECTORY(integrators)
ADD_SUBDIRECTORY(matrix_free)
ADD_SUBDIRECTORY(meshworker)

# A custom target to build the library:
ADD_CUSTOM_TARGET(build_library)

FOREACH(build ${DEAL_II_BUILD_TYPES})
  STRING(TOLOWER ${build} build_lowercase)

  #
  # Combine all ${build} OBJECT targets to a ${build} library:
  #
  FILE(STRINGS
    ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/deal_ii_objects_${build_lowercase}
    deal_ii_objects_${build_lowercase}
    )
  ADD_LIBRARY(${DEAL_II_BASE_NAME}${DEAL_II_${build}_SUFFIX}
    dummy.cc # Workaround for a bug in the Xcode generator
    ${deal_ii_objects_${build_lowercase}}
    )

  ADD_DEPENDENCIES(build_library ${DEAL_II_BASE_NAME}${DEAL_II_${_build}_SUFFIX})
  ADD_DEPENDENCIES(library ${DEAL_II_BASE_NAME}${DEAL_II_${_build}_SUFFIX})

  SET_TARGET_PROPERTIES(${DEAL_II_BASE_NAME}${DEAL_II_${build}_SUFFIX}
    PROPERTIES
    VERSION "${DEAL_II_PACKAGE_VERSION}"
    #
    # Sonaming: Well... we just use the version number.
    # No point to wrack one's brain over the question whether a new version of
    # a C++ library is still ABI backwards compatible :-]
    #
    SOVERSION "${DEAL_II_PACKAGE_VERSION}"
    LINK_FLAGS "${DEAL_II_LINKER_FLAGS} ${DEAL_II_LINKER_FLAGS_${build}}"
    COMPILE_DEFINITIONS "${DEAL_II_DEFINITIONS};${DEAL_II_DEFINITIONS_${build}}"
    COMPILE_FLAGS "${DEAL_II_CXX_FLAGS_${build}}"
    INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/${DEAL_II_LIBRARY_RELDIR}"
    ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${DEAL_II_LIBRARY_RELDIR}"
    LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${DEAL_II_LIBRARY_RELDIR}"
    RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${DEAL_II_EXECUTABLE_RELDIR}"
    )

  TARGET_LINK_LIBRARIES(${DEAL_II_BASE_NAME}${DEAL_II_${build}_SUFFIX}
    ${DEAL_II_EXTERNAL_LIBRARIES_${build}}
    ${DEAL_II_EXTERNAL_LIBRARIES}
    )

  FILE(MAKE_DIRECTORY
    ${CMAKE_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_RELDIR}
    )
  EXPORT(TARGETS ${DEAL_II_BASE_NAME}${DEAL_II_${build}_SUFFIX}
    FILE ${CMAKE_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_RELDIR}/${DEAL_II_PROJECT_CONFIG_NAME}Targets.cmake
    APPEND
    )

  INSTALL(TARGETS ${DEAL_II_BASE_NAME}${DEAL_II_${build}_SUFFIX}
    EXPORT ${DEAL_II_PROJECT_CONFIG_NAME}Targets
    RUNTIME DESTINATION ${DEAL_II_EXECUTABLE_RELDIR}
    LIBRARY DESTINATION ${DEAL_II_LIBRARY_RELDIR}
    ARCHIVE DESTINATION ${DEAL_II_LIBRARY_RELDIR}
    COMPONENT library
    )
ENDFOREACH()

INSTALL(EXPORT ${DEAL_II_PROJECT_CONFIG_NAME}Targets
  DESTINATION ${DEAL_II_PROJECT_CONFIG_RELDIR}
  COMPONENT library
  )

MESSAGE(STATUS "Setup library - Done")

=== tests/CMakeLists.txt ===
## ---------------------------------------------------------------------
## $Id: CMakeLists.txt 31739 2013-11-20 21:08:30Z maier $
##
## Copyright (C) 2013 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE at
## the top level of the deal.II distribution.
##
## ---------------------------------------------------------------------

#
# This is a small project that provides some custom targets that need a
# working, independent subproject because they are called back during
# configure phase.
#

IF(NOT DEFINED TEST_DIR)
  MESSAGE(FATAL_ERROR "\n
  The testsuite cannot be set up as an independent project.
  Please configure \"deal.II\" directly instead.\n\n"
    )
ENDIF()

CMAKE_MINIMUM_REQUIRED(VERSION 2.8.8)
PROJECT(testsuite NONE)

# Regenerate tests (run "make rebuild_cache" in subprojects):
ADD_CUSTOM_TARGET(regen_tests)

# Clean all tests
ADD_CUSTOM_TARGET(clean_tests)

FILE(GLOB _categories RELATIVE ${TEST_DIR} ${TEST_DIR}/*)
SET(_categories all-headers build_tests mesh_converter ${_categories})
LIST(REMOVE_DUPLICATES _categories)

FOREACH(_category ${_categories})
  IF( EXISTS ${CMAKE_SOURCE_DIR}/${_category}/CMakeLists.txt OR
      EXISTS ${TEST_DIR}/${_category}/CMakeLists.txt )

    ADD_CUSTOM_TARGET(regen_tests_${_category}
      COMMAND [ ! -d ${_category} ] || ${CMAKE_COMMAND}
        --build ${CMAKE_BINARY_DIR}/${_category} --target regenerate
      )
    ADD_DEPENDENCIES(regen_tests regen_tests_${_category})

    ADD_CUSTOM_TARGET(clean_tests_${_category}
      COMMAND [ ! -d ${_category} ] || ${CMAKE_COMMAND}
        --build ${CMAKE_BINARY_DIR}/${_category} --target clean
      )
    ADD_DEPENDENCIES(clean_tests clean_tests_${_category})

  ENDIF()
ENDFOREACH()

=== cmake/config/CMakeLists.txt ===
## ---------------------------------------------------------------------
## $Id: CMakeLists.txt 31861 2013-12-03 17:45:43Z maier $
##
## Copyright (C) 2012 - 2013 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE at
## the top level of the deal.II distribution.
##
## ---------------------------------------------------------------------

#
# This file sets up the project configuration consisting of
#
#   Make.global_options (legacy)
#   deal.IIConfig.cmake
#   deal.IIVersionConfig.cmake
#
# We support two configurations out of which deal.II can be used - directly
# from the build directory or after installation. So we have to prepare
# two distinct set ups.
#

MESSAGE(STATUS "Setup project configuration")

#
# Read in auxiliary include directories for the build directory
# configuration:
#
FILE(STRINGS
  ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/deal_ii_source_includes
  deal_ii_source_includes
  )

#
# Configure the template-arguments file
#
CONFIGURE_FILE( # for binary dir:
  ${CMAKE_CURRENT_SOURCE_DIR}/template-arguments.in
  ${CMAKE_BINARY_DIR}/${DEAL_II_COMMON_RELDIR}/template-arguments
  )


########################################################################
#                                                                      #
#              Setup and install the convenience macros:               #
#                                                                      #
########################################################################

FILE(COPY # for binary dir:
  ${CMAKE_SOURCE_DIR}/cmake/macros/macro_deal_ii_initialize_cached_variables.cmake
  ${CMAKE_SOURCE_DIR}/cmake/macros/macro_deal_ii_invoke_autopilot.cmake
  ${CMAKE_SOURCE_DIR}/cmake/macros/macro_deal_ii_setup_target.cmake
  DESTINATION ${CMAKE_BINARY_DIR}/${DEAL_II_CMAKE_MACROS_RELDIR}
  )
INSTALL(FILES # for installation:
  ${CMAKE_SOURCE_DIR}/cmake/macros/macro_deal_ii_initialize_cached_variables.cmake
  ${CMAKE_SOURCE_DIR}/cmake/macros/macro_deal_ii_invoke_autopilot.cmake
  ${CMAKE_SOURCE_DIR}/cmake/macros/macro_deal_ii_setup_target.cmake
  DESTINATION ${DEAL_II_CMAKE_MACROS_RELDIR}
  COMPONENT library
  )


########################################################################
#                                                                      #
#        Configure and install the cmake project configuration:        #
#                                                                      #
########################################################################

#
# Strip -Wno-deprecated from CMAKE_CXX_FLAGS so that deprecation warnings
# are actually shown for user code:
#
STRIP_FLAG(CMAKE_CXX_FLAGS "-Wno-deprecated")
STRIP_FLAG(CMAKE_CXX_FLAGS "-Wno-deprecated-declarations")

#
# Populate a bunch of CONFIG_* variables with useful information:
#

FOREACH(_build ${DEAL_II_BUILD_TYPES})

  IF(NOT "${CMAKE_BUILD_TYPE}" STREQUAL "DebugRelease")
    SET(_keyword "general")
  ELSE()
    IF(_build MATCHES DEBUG)
      SET(_keyword "debug")
    ELSE()
      SET(_keyword "optimized")
    ENDIF()
  ENDIF()

  #
  # Get library name directly from the target:
  #
  GET_TARGET_PROPERTY(_lib ${DEAL_II_BASE_NAME}${DEAL_II_${_build}_SUFFIX} LOCATION)
  GET_FILENAME_COMPONENT(CONFIG_LIBRARY_${_build} "${_lib}" NAME)

  IF(CMAKE_SYSTEM_NAME MATCHES "CYGWIN" OR CMAKE_SYSTEM_NAME MATCHES "Windows")
    SET(CONFIG_LIBRARIES_${_build}
      \${DEAL_II_PATH}/\${DEAL_II_EXECUTABLE_RELDIR}/${CONFIG_LIBRARY_${_build}}
      )
  ELSE()
    SET(CONFIG_LIBRARIES_${_build}
      \${DEAL_II_PATH}/\${DEAL_II_LIBRARY_RELDIR}/${CONFIG_LIBRARY_${_build}}
      )
  ENDIF()

  LIST(APPEND CONFIG_LIBRARIES_${_build}
    ${DEAL_II_EXTERNAL_LIBRARIES_${_build}}
    ${DEAL_II_EXTERNAL_LIBRARIES}
    )
  LIST(APPEND CONFIG_LIBRARIES
    ${_keyword}
    \${DEAL_II_LIBRARIES_${_build}}
    )

  SET(CONFIG_TARGET_${_build}
    ${DEAL_II_BASE_NAME}${DEAL_II_${_build}_SUFFIX}
    )
  LIST(APPEND CONFIG_TARGET
    ${_keyword}
    \${DEAL_II_TARGET_${_build}}
    )
ENDFOREACH()

#
# For binary dir:
#

SET(CONFIG_BUILD_DIR TRUE)
SET(CONFIG_INCLUDE_DIRS
  \${DEAL_II_PATH}/include
  \${DEAL_II_PATH}/include/deal.II
  ${CMAKE_SOURCE_DIR}/include/
  ${CMAKE_SOURCE_DIR}/include/deal.II
  ${deal_ii_source_includes}
  ${DEAL_II_USER_INCLUDE_DIRS}
  )
CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/Config.cmake.in
  ${CMAKE_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_RELDIR}/${DEAL_II_PROJECT_CONFIG_NAME}Config.cmake
  @ONLY
  )
CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/ConfigVersion.cmake.in
  ${CMAKE_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_RELDIR}/${DEAL_II_PROJECT_CONFIG_NAME}ConfigVersion.cmake
  @ONLY
  )

#
# For installation:
#

SET(CONFIG_BUILD_DIR FALSE)
SET(CONFIG_INCLUDE_DIRS
  \${DEAL_II_PATH}/\${DEAL_II_INCLUDE_RELDIR}
  \${DEAL_II_PATH}/\${DEAL_II_INCLUDE_RELDIR}/deal.II
  \${DEAL_II_PATH}/\${DEAL_II_INCLUDE_RELDIR}/deal.II/bundled
  ${DEAL_II_USER_INCLUDE_DIRS}
  )
CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/Config.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_NAME}Config.cmake
  @ONLY
  )
CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/ConfigVersion.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_NAME}ConfigVersion.cmake
  @ONLY
  )
INSTALL(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_NAME}Config.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_NAME}ConfigVersion.cmake
  DESTINATION ${DEAL_II_PROJECT_CONFIG_RELDIR}
  COMPONENT library
  )

#
# Append feature configuration to both configuration files:
#

SET(_files
  ${CMAKE_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_RELDIR}/${DEAL_II_PROJECT_CONFIG_NAME}Config.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_NAME}Config.cmake
  )
FOREACH(_file ${_files})
  FILE(APPEND ${_file}
    "\n\n#\n# Feature configuration:\n#\n\n"
    )
ENDFOREACH()
GET_CMAKE_PROPERTY(res VARIABLES)
FOREACH(var ${res})
  IF(var MATCHES "DEAL_II_WITH")
    FOREACH(_file ${_files})
      FILE(APPEND ${_file}
        "SET(${var} ${${var}})\n"
        )
    ENDFOREACH()
  ENDIF()
ENDFOREACH()


########################################################################
#                                                                      #
#         Configure and install the old Makefile configuration:        #
#                                                                      #
########################################################################

IF(DEAL_II_COMPONENT_COMPAT_FILES)
  #
  # Transform some cmake lists into a string that the old Makefile
  # mechanism actually understands:
  #

  FOREACH(build ${DEAL_II_BUILD_TYPES})

    TO_STRING_AND_ADD_PREFIX(MAKEFILE_DEFINITIONS_${build}
      "-D"
      ${DEAL_II_USER_DEFINITIONS}
      ${DEAL_II_USER_DEFINITIONS_${build}}
      )

    #
    # Ideally, DEAL_II_EXTERNAL_LIBRARIES should just contain a list of
    # full library paths. Nevertheless, filter out all elements that are
    # not a full path starting with "/" or that happen to be a "framework"
    # - we won't deal with that in Make.global_options.
    #

    SET(_libs)
    FOREACH(_lib
        ${DEAL_II_EXTERNAL_LIBRARIES_${build}}
        ${DEAL_II_EXTERNAL_LIBRARIES}
        )
      IF(_lib MATCHES "^\\s*\\/" AND NOT _lib MATCHES "\\.framework$")
        LIST(APPEND _libs "${_lib}")
      ENDIF()
    ENDFOREACH()

    TO_STRING(MAKEFILE_TARGETS_${build}
        $(D)/${DEAL_II_LIBRARY_RELDIR}/${CONFIG_LIBRARY_${build}}
        ${_libs}
        )

    SET(_paths)
    FOREACH(_lib
        $(D)/${DEAL_II_LIBRARY_RELDIR}/${CONFIG_LIBRARY_${build}}
        ${DEAL_II_EXTERNAL_LIBRARIES_${build}}
        ${DEAL_II_EXTERNAL_LIBRARIES}
        )

      #
      # Strip leading and trailing whitespace
      #
      STRING(STRIP "${_lib}" _lib)

      IF(_lib MATCHES "^\\/.*\\.framework$")
        #
        # We have a MacOSX framework
        #
        # TODO: What do?
        #

      ELSEIF(_lib MATCHES "^(\\/|\\$\\(D\\))")
        #
        # Full path: /path/to/libfoo.(so|dylib|etc):
        #

        # Extract library paths:
        GET_FILENAME_COMPONENT(_path ${_lib} PATH)
        LIST(APPEND _paths ${_path})

        LIST(APPEND MAKEFILE_LIBS_${build} ${_lib})

      ELSEIF(_lib MATCHES "^-l")
        #
        # Library is of the form "-lfoo":
        #
        LIST(APPEND MAKEFILE_LIBS_${build} ${_lib})

      ELSEIF(NOT _lib MATCHES "^\\s*$" AND NOT _lib MATCHES "\\.so(\\.[0-9]+)*$")
        #
        # Well in this case we just assume that we have to append a "-l"
        #

        LIST(APPEND MAKEFILE_LIBS_${build} "-l${_lib}")

      ELSE()
        #
        # For now, ignore the rest.
        #
        # TODO: What do?
        #
      ENDIF()

    ENDFOREACH()

    #
    # And build up an rpath:
    #
    SET(_rpath "")
    LIST(REMOVE_DUPLICATES _paths)
    FOREACH(_path ${_paths})
      SET(_rpath "${_rpath} -Wl,-rpath,${_path}")
    ENDFOREACH()

    TO_STRING(MAKEFILE_LIBS_${build} ${MAKEFILE_LIBS_${build}} ${_rpath})

    #
    # Set up our linker flags:
    #
    SET(MAKEFILE_LDFLAGS_${build}
      "${CMAKE_CXX_FLAGS} ${DEAL_II_CXX_FLAGS_${build}} ${DEAL_II_LINKER_FLAGS} ${DEAL_II_LINKER_FLAGS_${build}}"
      )
  ENDFOREACH()

  #
  # Boilerplate: The Make.global_options expects variables to be set to
  # yes, as is common for Makefiles.
  #
  COND_SET_TO_YES(DEAL_II_WITH_THREADS MAKEFILE_enablethreads)
  COND_SET_TO_YES(DEAL_II_WITH_FUNCTIONPARSER MAKEFILE_enableparser)
  COND_SET_TO_YES(BUILD_SHARED_LIBS MAKEFILE_enableshared)

  COND_SET_TO_YES(DEAL_II_WITH_PETSC MAKEFILE_PETSC)
  COND_SET_TO_YES(DEAL_II_WITH_SLEPC MAKEFILE_SLEPC)
  COND_SET_TO_YES(DEAL_II_WITH_TRILINOS MAKEFILE_TRILINOS)
  COND_SET_TO_YES(DEAL_II_WITH_HDF5 MAKEFILE_HDF5)
  COND_SET_TO_YES(DEAL_II_WITH_BLAS MAKEFILE_BLAS)
  COND_SET_TO_YES(DEAL_II_WITH_MUMPS MAKEFILE_MUMPS)
  COND_SET_TO_YES(DEAL_II_WITH_LAPACK MAKEFILE_LAPACK)
  COND_SET_TO_YES(DEAL_II_WITH_ARPACK MAKEFILE_ARPACK)
  COND_SET_TO_YES(DEAL_II_WITH_METIS MAKEFILE_METIS)
  COND_SET_TO_YES(DEAL_II_WITH_UMFPACK MAKEFILE_UMFPACK)
  COND_SET_TO_YES(DEAL_II_WITH_P4EST MAKEFILE_P4EST)
  COND_SET_TO_YES(DEAL_II_WITH_MPI MAKEFILE_MPI)

  #
  # For binary dir:
  #
  SET(MAKEFILE_D ${CMAKE_BINARY_DIR})
  TO_STRING_AND_ADD_PREFIX(MAKEFILE_INCLUDE_DIRS "${CMAKE_INCLUDE_FLAG_CXX}"
    $(D)/install
    $(D)/install/deal.II
    ${CMAKE_SOURCE_DIR}/include/
    ${CMAKE_SOURCE_DIR}/include/deal.II
    ${deal_ii_source_includes}
    ${DEAL_II_USER_INCLUDE_DIRS}
    )
  CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/Make.global_options.in
    ${CMAKE_BINARY_DIR}/${DEAL_II_COMMON_RELDIR}/Make.global_options
    )
  #
  # For installation:
  #
  SET(MAKEFILE_D ${CMAKE_INSTALL_PREFIX})
  TO_STRING_AND_ADD_PREFIX(MAKEFILE_INCLUDE_DIRS "${CMAKE_INCLUDE_FLAG_CXX}"
    $(D)/${DEAL_II_INCLUDE_RELDIR}
    $(D)/${DEAL_II_INCLUDE_RELDIR}/deal.II
    $(D)/${DEAL_II_INCLUDE_RELDIR}/deal.II/bundled
    ${DEAL_II_USER_INCLUDE_DIRS}
    )
  CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/Make.global_options.in
    ${CMAKE_CURRENT_BINARY_DIR}/Make.global_options
    )
  INSTALL(FILES
    ${CMAKE_BINARY_DIR}/${DEAL_II_COMMON_RELDIR}/template-arguments
    ${CMAKE_CURRENT_BINARY_DIR}/Make.global_options
    DESTINATION ${DEAL_II_COMMON_RELDIR}
    COMPONENT compat_files
    )
ENDIF()

MESSAGE(STATUS "Setup project configuration - Done")

=== cmake/scripts/CMakeLists.txt ===
## ---------------------------------------------------------------------
## $Id: CMakeLists.txt 31861 2013-12-03 17:45:43Z maier $
##
## Copyright (C) 2012 - 2013 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE at
## the top level of the deal.II distribution.
##
## ---------------------------------------------------------------------

ADD_EXECUTABLE(expand_instantiations_exe expand_instantiations.cc)
SET_TARGET_PROPERTIES(expand_instantiations_exe
  PROPERTIES OUTPUT_NAME expand_instantiations
  )

IF(DEAL_II_COMPONENT_COMPAT_FILES)
  MESSAGE(STATUS "Setup compat_files")

  #
  # Also build and install the old dependency_resolution executable:
  #

  ADD_EXECUTABLE(make_dependencies make_dependencies.cc)

  ADD_DEPENDENCIES(compat_files
    expand_instantiations_exe
    make_dependencies
    )

  SET_TARGET_PROPERTIES(expand_instantiations_exe make_dependencies
    PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${DEAL_II_COMMON_RELDIR}/scripts
    )
  INSTALL(TARGETS expand_instantiations_exe make_dependencies
    DESTINATION ${DEAL_II_COMMON_RELDIR}/scripts
    COMPONENT compat_files
    )
  MESSAGE(STATUS "Setup compat_files - Done")
ENDIF()

=== contrib/mesh_conversion/CMakeLists.txt ===
## ---------------------------------------------------------------------
## $Id: CMakeLists.txt 31884 2013-12-04 18:02:47Z maier $
##
## Copyright (C) 2012 - 2013 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE at
## the top level of the deal.II distribution.
##
## ---------------------------------------------------------------------

CMAKE_MINIMUM_REQUIRED(VERSION 2.8)
#PROJECT(mesh_converter)

IF("${DEAL_II_EXECUTABLE_RELDIR}" STREQUAL "")
  SET(DEAL_II_EXECUTABLE_RELDIR "bin")
ENDIF()

ADD_EXECUTABLE(mesh_converter_exe
  Main.cc
  MeshConversion.cc
  )
SET_TARGET_PROPERTIES(mesh_converter_exe
  PROPERTIES
  OUTPUT_NAME mesh_converter
  RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${DEAL_II_EXECUTABLE_RELDIR}"
  )

ADD_DEPENDENCIES(mesh_converter mesh_converter_exe)

INSTALL(TARGETS mesh_converter_exe
  RUNTIME DESTINATION ${DEAL_II_EXECUTABLE_RELDIR}
  COMPONENT mesh_converter
  )
EXPORT(TARGETS mesh_converter_exe
  FILE
  ${CMAKE_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_RELDIR}/${DEAL_II_PROJECT_CONFIG_NAME}Targets.cmake
  APPEND
  )

=== contrib/parameter_gui/CMakeLists.txt ===
## ---------------------------------------------------------------------
## $Id: CMakeLists.txt 31884 2013-12-04 18:02:47Z maier $
##
## Copyright (C) 2012 - 2013 by Martin Steigemann and Wolfgang Bangerth
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE at
## the top level of the deal.II distribution.
##
## ---------------------------------------------------------------------

CMAKE_MINIMUM_REQUIRED(VERSION 2.8)
#PROJECT(parameter_gui)

IF("${DEAL_II_EXECUTABLE_RELDIR}" STREQUAL "")
  SET(DEAL_II_EXECUTABLE_RELDIR "bin")
ENDIF()

FIND_PACKAGE(Qt4 REQUIRED QtCore QtGui QtXml)
MARK_AS_ADVANCED(QT_QMAKE_EXECUTABLE)

INCLUDE(${QT_USE_FILE})

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

QT4_WRAP_CPP(SOURCE_MOC
  browse_lineedit.h
  info_message.h
  mainwindow.h
  parameter_delegate.h
  )

QT4_ADD_RESOURCES(SOURCE_RCC
  application.qrc
  )

ADD_EXECUTABLE(parameter_gui_exe
  browse_lineedit.cpp
  info_message.cpp
  main.cpp
  mainwindow.cpp
  parameter_delegate.cpp
  xml_parameter_reader.cpp
  xml_parameter_writer.cpp
  ${SOURCE_MOC}
  ${SOURCE_RCC}
  )
SET_TARGET_PROPERTIES(parameter_gui_exe
  PROPERTIES
  OUTPUT_NAME parameter_gui
  RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${DEAL_II_EXECUTABLE_RELDIR}"
  )
TARGET_LINK_LIBRARIES(parameter_gui_exe ${QT_LIBRARIES})

ADD_DEPENDENCIES(parameter_gui parameter_gui_exe)

INSTALL(TARGETS parameter_gui_exe
  RUNTIME DESTINATION ${DEAL_II_EXECUTABLE_RELDIR}
  COMPONENT parameter_gui
  )
EXPORT(TARGETS parameter_gui_exe
  FILE
  ${CMAKE_BINARY_DIR}/${DEAL_II_PROJECT_CONFIG_RELDIR}/${DEAL_II_PROJECT_CONFIG_NAME}Targets.cmake
  APPEND
  )

=== doc/doxygen/CMakeLists.txt ===
## ---------------------------------------------------------------------
## $Id: CMakeLists.txt 31904 2013-12-06 01:34:01Z maier $
##
## Copyright (C) 2012 - 2013 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE at
## the top level of the deal.II distribution.
##
## ---------------------------------------------------------------------

#
# Generate the source documentation via doxygen:
#

FIND_PACKAGE(Perl)
FIND_PACKAGE(Doxygen)

#
# Do we have all necessary dependencies?
#
IF(NOT PERL_FOUND)
  MESSAGE(FATAL_ERROR
    "Could not find a perl installation which is required for building the documentation"
    )
ENDIF()
IF(NOT DOXYGEN_FOUND)
  MESSAGE(FATAL_ERROR
    "Could not find doxygen which is required for building the documentation"
    )
ENDIF()

#
# A glob. I'm sorry
#
file(GLOB DEAL_II_STEPS
  ${CMAKE_SOURCE_DIR}/examples/step-*
  )

#
# Prepare the example steps for doxygen:
#
ADD_SUBDIRECTORY(tutorial) # uses ${DEAL_II_STEPS}

#
# Prepare auxiliary files for doxygen:
#
CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/options.dox.in
  ${CMAKE_CURRENT_BINARY_DIR}/options.dox
  )

CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/scripts/mod_header.pl.in
  ${CMAKE_CURRENT_BINARY_DIR}/scripts/mod_header.pl
  )

CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/scripts/mod_footer.pl.in
  ${CMAKE_CURRENT_BINARY_DIR}/scripts/mod_footer.pl
  )


#
# Generate header, footer and style files for doxygen
#
ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/header.html
    ${CMAKE_CURRENT_BINARY_DIR}/footer.html
  COMMAND ${DOXYGEN_EXECUTABLE} -w html header.html footer.html style.css options.dox
  COMMAND ${PERL_EXECUTABLE} -pi~ ${CMAKE_CURRENT_BINARY_DIR}/scripts/mod_header.pl header.html
  COMMAND ${PERL_EXECUTABLE} -pi~ ${CMAKE_CURRENT_BINARY_DIR}/scripts/mod_footer.pl footer.html
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/options.dox
    ${CMAKE_CURRENT_BINARY_DIR}/scripts/mod_header.pl
    ${CMAKE_CURRENT_BINARY_DIR}/scripts/mod_footer.pl
  )

#
# Finalize the doxygen configuration:
#
file(GLOB _doxygen_input
  ${CMAKE_CURRENT_SOURCE_DIR}/headers/*.h
  ${CMAKE_SOURCE_DIR}/contrib/parameter_gui/*.h
  ${CMAKE_SOURCE_DIR}/contrib/parameter_gui/main.cpp
  ${CMAKE_SOURCE_DIR}/doc/news/*.h
  ${CMAKE_SOURCE_DIR}/include/deal.II/**/*.h
  )
LIST(APPEND _doxygen_input
  ${CMAKE_BINARY_DIR}/include/deal.II/base/config.h
  ${CMAKE_CURRENT_BINARY_DIR}/tutorial/tutorial.h
  )
FOREACH(_step ${DEAL_II_STEPS})
  GET_FILENAME_COMPONENT(_step "${_step}" NAME)
  LIST(APPEND _doxygen_input
    ${CMAKE_CURRENT_BINARY_DIR}/tutorial/${_step}.h
    )
ENDFOREACH()
TO_STRING(_doxygen_input_string ${_doxygen_input})

file(GLOB _doxygen_image_path
  ${CMAKE_CURRENT_SOURCE_DIR}/images
  ${CMAKE_SOURCE_DIR}/examples/*/doc
  ${CMAKE_SOURCE_DIR}/contrib/parameter_gui/images

  ${CMAKE_CURRENT_BINARY_DIR}/images
  )
TO_STRING(_doxygen_image_path_string ${_doxygen_image_path})

FILE(APPEND "${CMAKE_CURRENT_BINARY_DIR}/options.dox"
  "
  INPUT=${_doxygen_input_string}
  IMAGE_PATH=${_doxygen_image_path_string}
  "
  )

#
# And, finally, call doxygen:
#
ADD_CUSTOM_COMMAND(
  OUTPUT
    ${CMAKE_BINARY_DIR}/doxygen.log
  COMMAND ${DOXYGEN_EXECUTABLE}
    ${CMAKE_CURRENT_BINARY_DIR}/options.dox
    > ${CMAKE_BINARY_DIR}/doxygen.log 2>&1 # *pssst*
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS
    tutorial
    ${CMAKE_CURRENT_BINARY_DIR}/options.dox
    ${CMAKE_CURRENT_BINARY_DIR}/header.html
    ${CMAKE_CURRENT_BINARY_DIR}/footer.html
    ${_doxygen_input}
  COMMENT "Generating documentation via doxygen."
  VERBATIM
  )
ADD_CUSTOM_TARGET(doxygen ALL
  DEPENDS ${CMAKE_BINARY_DIR}/doxygen.log
  )
ADD_DEPENDENCIES(documentation doxygen)

INSTALL(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/deal.tag
  DESTINATION ${DEAL_II_DOCHTML_RELDIR}/doxygen
  COMPONENT documentation
  )

INSTALL(DIRECTORY
  ${CMAKE_CURRENT_BINARY_DIR}/deal.II
  DESTINATION ${DEAL_II_DOCHTML_RELDIR}/doxygen
  COMPONENT documentation
  )

=== debian/changelog ===
deal.ii (8.1.0-6ubuntu1) xenial; urgency=medium

  * Use -fPIC instead of -fpic to fix FTBFS on arm64, thanks Matthias Klose.

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 01 Apr 2016 08:04:21 +0200

deal.ii (8.1.0-6) unstable; urgency=medium

  * Revert fix for doxygen deal.tag since it moved back
  * Use secure URIs for VCS fields
  * Migrate from libdeal.ii-dbg to ddebs, bump debhelper build-dependency
  * Update obsolete source URL in debian/copyright
  * Bump Standards-Version to 3.9.7, no further changes

 -- Graham Inggs <ginggs@debian.org>  Wed, 16 Mar 2016 12:33:02 +0200

deal.ii (8.1.0-5) unstable; urgency=medium

  * Fix FTBFS due to doxygen deal.tag moving (Closes: #789975)
  * Use an explicit cast to fix FTBFS with new boost and c++11
  * Update debian/watch
  * Enable cryptographic signature verification
  * Add myself to uploaders

 -- Graham Inggs <ginggs@debian.org>  Wed, 16 Sep 2015 21:44:26 +0200

deal.ii (8.1.0-4) unstable; urgency=medium

  * Fix broken build dependencies for buildds
  * Fix imprecision in copyright file

 -- Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>  Fri, 18 Apr 2014 13:38:16 +0200

deal.ii (8.1.0-3) unstable; urgency=medium

  * Fix privacy breaches in html documentation v2.

 -- Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>  Mon, 03 Mar 2014 13:37:27 +0100

deal.ii (8.1.0-2) unstable; urgency=medium

  * Add forgotten copyright notice for a file under doc/external-libs/.
  * Add a watch file.
  * Fix short description for dbg, dev and doc package.
  * Fix privacy breaches in html documentation.
  * Remove empty directories from documentation.
  * Rename shared libraries to libdeal.ii[.g].so to match package name.
  * Change library name to match package name.
  * Do not compress example source code.
  * Reogranize patches.

 -- Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>  Sat, 01 Mar 2014 19:38:47 +0100

deal.ii (8.1.0-1) unstable; urgency=medium

  * Initial release.

 -- Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>  Fri, 03 Jan 2014 20:52:34 +0100

=== debian/control ===
Source: deal.ii
Section: libs
Priority: optional
Standards-Version: 3.9.7
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>, Graham Inggs <ginggs@debian.org>
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/deal.ii.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/deal.ii.git
Homepage: http://www.dealii.org/
Build-Depends: debhelper (>= 9.20150628), cmake, doxygen, graphviz,
 liblapack-dev, libsuitesparse-dev, libtbb-dev, libboost-iostreams-dev,
 libboost-serialization-dev, libboost-system-dev, libboost-thread-dev, zlib1g-dev

Package: libdeal.ii-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libdeal.ii-8.1.0 (= ${binary:Version}),
 liblapack-dev, libsuitesparse-dev, libtbb-dev, libboost-iostreams-dev,
 libboost-serialization-dev, libboost-system-dev, libboost-thread-dev, zlib1g-dev
Recommends: cmake
Description: Differential Equations Analysis Library - development files
 deal.II is a C++ program library targeted at the computational solution of
 partial differential equations using adaptive finite elements. It uses
 state-of-the-art programming techniques to offer you a modern interface to the
 complex data structures and algorithms required.
 .
 This package contains the development files.

Package: libdeal.ii-8.1.0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Finite Element Differential Equations Analysis Library
 deal.II is a C++ program library targeted at the computational solution of
 partial differential equations using adaptive finite elements. It uses
 state-of-the-art programming techniques to offer you a modern interface to the
 complex data structures and algorithms required.
 .
 This package contains the shared libraries.

Package: libdeal.ii-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Differential Equations Analysis Library - html doc. and examples
 deal.II is a C++ program library targeted at the computational solution of
 partial differential equations using adaptive finite elements. It uses
 state-of-the-art programming techniques to offer you a modern interface to the
 complex data structures and algorithms required.
 .
 This package contains the documentation and examples.

=== debian/rules ===
#! /usr/bin/make -f

DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=DebugRelease \
	-DDEAL_II_ALLOW_AUTODETECTION=OFF \
	-DDEAL_II_ALLOW_BUNDLED=OFF \
	-DDEAL_II_ALLOW_PLATFORM_INTROSPECTION=OFF \
	-DDEAL_II_COMPONENT_DOCUMENTATION=ON \
	-DDEAL_II_COMPONENT_MESH_CONVERTER=OFF \
	-DDEAL_II_COMPONENT_COMPAT_FILES=OFF \
	-DDEAL_II_WITH_LAPACK=ON \
	-DDEAL_II_WITH_THREADS=ON \
	-DDEAL_II_WITH_UMFPACK=ON \
	-DDEAL_II_WITH_ZLIB=ON \
	-DCMAKE_INSTALL_RPATH_USE_LINK_PATH=OFF \
	-DDEAL_II_BASE_NAME="deal.ii" \
	-DDEAL_II_CMAKE_MACROS_RELDIR=share/deal.ii/cmake/macros \
	-DDEAL_II_DOCHTML_RELDIR=share/doc/libdeal.ii-doc/html \
	-DDEAL_II_DOCREADME_RELDIR=share/doc/libdeal.ii-doc \
	-DDEAL_II_EXAMPLES_RELDIR=share/doc/libdeal.ii-doc/examples \
	-DDEAL_II_PROJECT_CONFIG_RELDIR=share/cmake/deal.II \
	-DDEAL_II_LIBRARY_RELDIR=lib/$(DEB_HOST_MULTIARCH)

TMP_DOC := debian/tmp/usr/share/doc/libdeal.ii-doc
override_dh_auto_install:
	dh_auto_install
	# Copy over all external html resources:
	cp -r doc/doxygen/deal.II/images $(TMP_DOC)/html/doxygen/deal.II/
	# Replace links to external html resources by local links:
	sed -i 's#"http://www.dealii.org/images/steps/developer/\(step-.*\)"#"images/\1"#g' \
		$(TMP_DOC)/html/doxygen/deal.II/step_*.html
	# Remove external links to the W3C validator icon:
	find $(TMP_DOC)/html \
		-type f -name '*.html' -exec sed -i 's#\(<img.*w3.org.*\)</a>#</a>#' {} \;
	# Remove a java script embedding to google groups:
	sed -i  -e 's#.*getElementById.*forum_embed.*##g' \
		-e 's#.*groups\.google\.com/forum/embed.*##g' \
		$(TMP_DOC)/html/mail.html
	# Remove superfluous license file
	rm $(TMP_DOC)/LICENSE
	# Remove empty directories
	rm -r $(TMP_DOC)/examples/step-35/lib
	rmdir $(TMP_DOC)/html/glossary

override_dh_compress:
	# Do not compress example source code, and icons:
	dh_compress -X.cc -X.ico

override_dh_strip:
	dh_strip --ddeb-migration='libdeal.ii-dbg (<< 8.1.0-6~)'


VERSION := 8.1.0
get-orig-source:
	wget --no-clobber -O deal.ii-$(VERSION).tar.gz https://dealii.googlecode.com/files/deal.II-$(VERSION).tar.gz
	wget --no-clobber -O deal.ii-doc-$(VERSION).tar.gz https://dealii.googlecode.com/files/deal.offlinedoc-$(VERSION).tar.gz
	mkdir deal.ii-$(VERSION)
	tar --strip-components=1 -C deal.ii-$(VERSION) -xzf deal.ii-$(VERSION).tar.gz
	mkdir -p deal.ii-$(VERSION)/doc/doxygen/deal.II
	tar -C deal.ii-$(VERSION) -xzf deal.ii-doc-$(VERSION).tar.gz doc/doxygen/deal.II/images
	set -e; cd deal.ii-$(VERSION); \
		rm -rf bundled
	tar -cJf deal.ii_$(VERSION).orig.tar.xz deal.ii-$(VERSION)
	rm -rf deal.ii-$(VERSION)

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/,filenamemangle=s/.+\/dealii-(\d\S*)\.tar\.gz/deal\.ii-$1\.tar\.gz/ \
https://github.com/dealii/dealii/releases .*/dealii-(\d+\.\d+\.\d+)\.tar\.gz
